=== debian/changelog ===
golang-github-pingcap-kvproto (6.1.0~alpha-1) unstable; urgency=medium

  * Initial release (Closes: #1107496)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 05 Jun 2025 12:39:19 +0000
